source [file join $script_path board.tcl]
source [file join $script_path map.tcl]


# Paccraft --
#
#    a warcraft clone

inherit Paccraft Control
method Paccraft constructor {} {
	PaccraftA ${objName}_abst $objName
	PaccraftP ${objName}_pres $objName
	this inherited "" ${objName}_abst ${objName}_pres
	
	Board ${objName}_board $objName {1,1 Unit 12,24 Unit}
	Map ${objName}_map $objName [$this(presentation) get_panel board] ${objName}_board	
}

method Paccraft destructor {} {
	this inherited
}


# PaccraftA --
#
#   the abstraction for paccraft

inherit PaccraftA Abstraction
method PaccraftA constructor {control} {
	this inherited $control
}


# PaccraftP --
#
#   the presentaiton for paccraft

inherit PaccraftP Presentation
method PaccraftP constructor {control} {
	this inherited $control
	
	set this(window) [toplevel .window]
	wm title $this(window) "PacCraft"
	wm minsize $this(window) 800 600
	wm protocol $this(window) WM_DELETE_WINDOW "$this(control) dispose"
	
	# left panel 
	frame $this(window).left -bg black
	pack $this(window).left -side left -fill y 
	
	set this(info) [frame $this(window).left.info -width 150 -bg grey]
	pack $this(info) -side top -fill y -expand 1
	
	# main area
	frame $this(window).right -bg black
	pack $this(window).right -fill both -expand 1

	set this(board) [frame $this(window).right.board]
	pack $this(board) -fill both -expand 1
}

method PaccraftP destructor {} {
	destroy $this(window)
}

method PaccraftP get_panel {name} {
	return $this($name)
}

